CoCoA-5 - Bug #1384

NewPolyRing and SymbolRange
07 Jan 2020 16:42 - John Abbott

Status: Closed Start date: 07 Jan 2020
Priority: Normal Due date:

Assignee: Anna Maria Bigatti % Done: 100%
Category: enhancing/improving Estimated time: 0.00 hour
Target version: CoCoA-5.3.0 Spent time: 2.35 hours
Description

What should SymbolRange do if there are no indets in the range?
What should NewPolyRing do if the result of SymbolRange is empty?

Currently the result is an unhelpful error message.

2020-02 improved error message

Related issues:

Related to CoCoA-5 - Bug #1383: NewPolyRing on MS Windows Closed 07 Jan 2020
Related to CoCoA-5 - Bug #1273: NewPolyRing and SymbolRange together make a c... Closed 29 Apr 2019
History

#1 - 07 Jan 2020 16:42 - John Abbott
- Related to Bug #1383: NewPolyRing on MS Windows added

#2 - 07 Jan 2020 16:45 - John Abbott

Here is a session sample:

>>> NewPolyRing (QQ, SymbolRange ("x",2,1));

—-—> ERROR: Wrong number of indet names when creating a PPMonoid
——> [CoCoALib] NewPolyRing_DMPI pseudo ctor

—-—> NewPolyRing (QQ, SymbolRange ("x",2,1));

> AAAAAAAAAAAAAAAAANNNNAAAAAAAAAAAANNAN

Currently SymbolRange returns an empty list, which evidently NewPolyRing does not like.
A KISS solution is simple to give a better error message when arg2 of NewPolyRing is empty.

#3 - 09 Jan 2020 12:00 - Anna Maria Bigatti
My opinion:

What should SymbolRange do if there are no indets in the range?
empty list (non error)

What should NewPolyRing do if the result of SymbolRange is empty?
Give error
I'm cleaning up (right now) the input sanity checks for polynomial rings, they are quite messy and incoherent in the different implementations.

#4 - 09 Jan 2020 12:21 - Anna Maria Bigatti
Now using ERR::Empty (maybe not ideal, but better)

/**/ NewPolyRing (QQ, "");

——> ERROR: Empty list or vector

—-—> [CoCoALib] NewPolyRing DMPI pseudo ctor
——> NewPolyRing (QQ, "");

—_—> ANANNANANNNNNNNNNNNNNNNAN

/**/ NewPolyRing(QQ, [1);

——> ERROR: Empty list or vector

——> [CoCoALib] NewPolyRing_DMPI pseudo ctor
-—> NewPolyRing (QQ, []1);

> AAAAAAANAAANAANAAANA

#5 - 09 Jan 2020 17:40 - Anna Maria Bigatti

Done and cvs-ed.

| cleaned up the code in the 3 files RingDistr.. and ediffed them so they are a little bit more similar (therefore, easier to maintain)

#6 - 09 Jan 2020 21:08 - John Abbott
- Status changed from New to Resolved
- Assignee set to Anna Maria Bigatti

- % Done changed from 0 to 80

It appears to work fine for me (Linux).

#7 - 28 Jan 2020 10:15 - John Abbott

- Status changed from Resolved to Feedback

- Target version changed from CoCo0A-5.4.0 to CoCoA-5.3.0
- % Done changed from 80 to 90

#8 - 13 Feb 2020 09:28 - Anna Maria Bigatti

- Description updated
#9 - 13 Feb 2020 09:29 - Anna Maria Bigatti
- Status changed from Feedback to Closed

- % Done changed from 90 to 100

#10 - 13 Feb 2020 09:29 - Anna Maria Bigatti

- Related to Bug #1273: NewPolyRing and SymbolRange together make a crash added
